package devmanuals.com;

import java.util.*;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;

public class Client extends Server {
	public static void main(String[] args) {
		new Client().go();
	}

	public void go() {
		final Server server = new Server();
		server.start();

		for (int i = 0; i < 2; i++) {
			final Request request = createRequest(i);
			server.accept(request);
		}
	}

	Request createRequest(final int index) {
		return new Request() {
			public void execute() {
				for (int i = 0; i <= 40; i += 20) {
					sleep((new Random().nextInt(5) + 1) * 1000);
					System.out.println(String.format(
							"request: %d completed: %d%%", index, i));
				}
				System.out.println(String.format("reqest %d completed", index));
			}

		};
	}

	private void sleep(int millis) {
		try {
			Thread.sleep(millis);
		} catch (InterruptedException e) {

		}
	}
}

class Server extends Thread {
	private BlockingQueue<Request> queue = new LinkedBlockingQueue<Request>();

	public void accept(Request request) {
		queue.add(request);
	}

	public void run() {
		while (true)
			try {
				execute(queue.take());
			} catch (InterruptedException e) {
			}
	}

	public interface Request {
		void execute();
	}

	private void execute(final Request request) {
		new Thread(new Runnable() {
			public void run() {
				request.execute();
			}
		}).start();
	}
}